main_IT		equ		?main_IT@@3PAUinstr_properties@@A
context		equ		?context@@3Ux86_emul_context@@A
op_prop		equ		?op_prop@@3PAUoperand_properties@@A
op_cache	equ		?op_cache@@3PAUfixed_cache@@A
instr_params	equ		?instr_params@@3Uadditional_instr_params@@A

OPERAND_VALUE		equ		01h
OPERAND_ADDRv		equ		02h
OPERAND_ADDRt		equ		04h
OPERAND_ADDR		equ		08h
OPERAND_SIZE		equ		10h


OPERAND_READ		equ		20h
OPERAND_WRITE		equ		40h


FLAG_C		equ	1h
FLAG_P		equ	4h
FLAG_A		equ	10h
FLAG_Z		equ	40h
FLAG_S		equ	80h
FLAG_T		equ	100h
FLAG_I		equ	200h
FLAG_D		equ	400h
FLAG_O		equ	800h

NON_PRIVILEGED_FLAGS		equ		0001101111111111b
PRIVILEGED_FLAGS		equ		1110010000000000b


NO_PREFIX	equ		0
REPE_PREFIX	equ		1
REPNE_PREFIX	equ		2

OPERAND1	equ		op_prop[sizeof operand_properties * 0]
OPERAND2	equ		op_prop[sizeof operand_properties * 1]
OPERAND3	equ		op_prop[sizeof operand_properties * 2]


loadflags macro
pushf
push	WORD PTR context.R_flags
popf
endm

saveflags macro
pushf
and	WORD PTR [esp], NON_PRIVILEGED_FLAGS
movzx	edx, WORD PTR context.R_flags
and	edx, PRIVILEGED_FLAGS
or	dx, [esp]
mov	context.R_flags, edx
add	esp, 2
popf
endm

storeflags macro flags
pushfd
pop	eax
and	context.R_flags, not (flags)
and	eax, flags
or	context.R_flags, eax
endm


ifdef X86_64
d_addr			equ			dq
d_def			equ			dq
sADDR			equ			QWORD
sDEFAULT		equ			QWORD

else
d_addr			equ			dd
d_def			equ			dd
sADDR			equ			DWORD
sDEFAULT		equ			DWORD

endif


instr_properties struc
ip_mask		db		3 dup(?)
ip_stack_use	db		?
ip_handler	d_addr		?
instr_properties ends


additional_instr_params struc
aip_prefix		d_def		?
aip_instr_size		d_def		?
aip_stack_buffer	db		64 dup(?)
additional_instr_params ends


operand_properties struc
op_addr		d_addr		?
op_size		d_def		?
op_data		db		64 dup(?)
operand_properties ends



fixed_cache struc
fc_addr_in_base		d_addr		?
fc_size			d_def		?
fc_data			db		64(?)
fixed_cache ends



breakpoint struc
b_addr		d_addr		?
b_size		d_def		?
b_type		d_def		?
breakpoint ends


x86_emul_context struc

 ;General registers
R_ax		d_def		?
R_cx		d_def		?
R_dx		d_def		?
R_bx		d_def		?
R_sp		d_def		?
R_bp		d_def		?
R_si		d_def		?
R_di		d_def		?

 ;Control registers
R_flags		d_def		?
R_ip		d_def		?

align 16
union
R_st0		dt		?
R_mm0		dq		?
ends

align 16
union
R_st1		dt		?
R_mm1		dq		?
ends

align 16
union
R_st2		dt		?
R_mm2		dq		?
ends

align 16
union
R_st3		dt		?
R_mm3		dq		?
ends

align 16
union
R_st4		dt		?
R_mm4		dq		?
ends

align 16
union
R_st5		dt		?
R_mm5		dq		?
ends

align 16
union
R_st6		dt		?
R_mm6		dq		?
ends

align 16
union
R_st7		dt		?
R_mm7		dq		?
ends

align 16
R_es		dw		?
R_cs		dw		?
R_ss		dw		?
R_ds		dw		?
R_fs		dw		?
R_gs		dw		?

 ;Debug registers
R_dr0		d_def		?
R_dr1		d_def		?
R_dr2		d_def		?
R_dr3		d_def		?
R_dr6		d_def		?
R_dr7		d_def		?

 ;Control registers
R_cr0		d_def		?
R_cr2		d_def		?
R_cr3		d_def		?
R_cr4		d_def		?

 ;Task register
R_tr		dw			?

align 16
  ;breakpoints area
breakpoints_number	d_def		?
breakpoints			breakpoint	32 dup(<>)

sys_breakpoint_addr	d_addr	?
x86_emul_context ends
