#define __NT__
#define __IDP__

#include "main.h"
#include <ida.hpp>
#include <idp.hpp>
#include <bytes.hpp>
#include <loader.hpp>
#include <kernwin.hpp>
#include <allins.hpp>



/* Array, using for associate constant in allins.hpp file
   to structure */

#ifdef X86_64

	//Not supported now
sDEFAULT	instructions_associate[] = {NN_last, sizeof(instructions_associate) /  sizeof(sDEFAULT) / 2};

#else

sDEFAULT	instructions_associate[] = {
0, 0,		//Number of instructions
NN_aaa, 1, 
NN_aad, 2,
NN_aam, 3,
NN_aas, 4,
NN_adc, 5,
NN_add, 6,
NN_and, 7,
NN_arpl, 8,
NN_bound, 9,
NN_bsf, 10,
NN_bsr, 11,
NN_bt, 12,
NN_btc, 13,
NN_btr, 14,
NN_bts, 15,
NN_call, 16,
NN_callfi, 17,
NN_callni, 18,
NN_cbw, 19,
NN_cwde, 20,
NN_clc, 22,
NN_cld, 23,
NN_cli, 24,
NN_clts, 25,
NN_cmc, 26,
NN_cmp, 27,
NN_cmps, 28,
NN_cwd, 29,
NN_cdq, 30,
NN_daa, 32,
NN_das, 33,
NN_dec, 34,
NN_div, 35,
NN_enterw, 36,
NN_enter, 37,
NN_enterd, 38,
NN_hlt, 40,
NN_idiv, 41,
NN_imul, 42,
NN_in, 43,
NN_inc, 44,
NN_ins, 45,
NN_int, 46,
NN_into, 47,
NN_int3, 48,
NN_iretw, 49,
NN_iret, 50,
NN_iretd, 51,
NN_ja, 53,
NN_jae, 54,
NN_jb, 55,
NN_jbe, 56,
NN_jc, 57,
NN_jcxz, 58,
NN_jecxz, 59,
NN_je, 61,
NN_jg, 62,
NN_jge, 63,
NN_jl, 64,
NN_jle, 65,
NN_jna, 66,
NN_jnae, 67,
NN_jnb, 68,
NN_jnbe, 69,
NN_jnc, 70,
NN_jne, 71,
NN_jng, 72,
NN_jnge, 73,
NN_jnl, 74,
NN_jnle, 75,
NN_jno, 76,
NN_jnp, 77,
NN_jns, 78,
NN_jnz, 79,
NN_jo, 80,
NN_jp, 81,
NN_jpe, 82,
NN_jpo, 83,
NN_js, 84,
NN_jz, 85,
NN_jmp, 86,
NN_jmpfi, 87,
NN_jmpni, 88,
NN_jmpshort, 89,
NN_lahf, 90,
NN_lar, 91,
NN_lea, 92,
NN_leavew, 93,
NN_leave, 94,
NN_leaved, 95,
NN_lgdt, 97,
NN_lidt, 98,
NN_lgs, 99,
NN_lss, 100,
NN_lds, 101,
NN_les, 102,
NN_lfs, 103,
NN_lldt, 104,
NN_lmsw, 105,
NN_lock, 106,
NN_lods, 107,
NN_loopw, 108,
NN_loop, 109,
NN_loopd, 110,
NN_loopwe, 112,
NN_loope, 113,
NN_loopde, 114,
NN_loopwne, 116,
NN_loopne, 117,
NN_loopdne, 118,
NN_lsl, 120,
NN_ltr, 121,
NN_mov, 122,
NN_movsp, 123,
NN_movs, 124,
NN_movsx, 125,
NN_movzx, 126,
NN_mul, 127,
NN_neg, 128,
NN_nop, 129,
NN_not, 130,
NN_or, 131,
NN_out, 132,
NN_outs, 133,
NN_pop, 134,
NN_popaw, 135,
NN_popa, 136,
NN_popad, 137,
NN_popfw, 139,
NN_popf, 140,
NN_popfd, 141,
NN_push, 143,
NN_pushaw, 144,
NN_pusha, 145,
NN_pushad, 146,
NN_pushfw, 148,
NN_pushf, 149,
NN_pushfd, 150,
NN_rcl, 152,
NN_rcr, 153,
NN_rol, 154,
NN_ror, 155,
NN_rep, 156,
NN_repe, 157,
NN_repne, 158,
NN_retn, 159,
NN_retf, 160,
NN_sahf, 161,
NN_sal, 162,
NN_sar, 163,
NN_shl, 164,
NN_shr, 165,
NN_sbb, 166,
NN_scas, 167,
NN_seta, 168,
NN_setae, 169,
NN_setb, 170,
NN_setbe, 171,
NN_setc, 172,
NN_sete, 173,
NN_setg, 174,
NN_setge, 175,
NN_setl, 176,
NN_setle, 177,
NN_setna, 178,
NN_setnae, 179,
NN_setnb, 180,
NN_setnbe, 181,
NN_setnc, 182,
NN_setne, 183,
NN_setng, 184,
NN_setnge, 185,
NN_setnl, 186,
NN_setnle, 187,
NN_setno, 188,
NN_setnp, 189,
NN_setns, 190,
NN_setnz, 191,
NN_seto, 192,
NN_setp, 193,
NN_setpe, 194,
NN_setpo, 195,
NN_sets, 196,
NN_setz, 197,
NN_sgdt, 198,
NN_sidt, 199,
NN_shld, 200,
NN_shrd, 201,
NN_sldt, 202,
NN_smsw, 203,
NN_stc, 204,
NN_std, 205,
NN_sti, 206,
NN_stos, 207,
NN_str, 208,
NN_sub, 209,
NN_test, 210,
NN_verr, 211,
NN_verw, 212,
NN_wait, 213,
NN_xchg, 214,
NN_xlat, 215,
NN_xor, 216,
NN_cmpxchg, 217,
NN_bswap, 218,
NN_xadd, 219,
NN_invd, 220,
NN_wbinvd, 221,
NN_invlpg, 222,
NN_rdmsr, 223,
NN_wrmsr, 224,
NN_cpuid, 225,
NN_cmpxchg8b, 226,
NN_rdtsc, 227,
NN_rsm, 228,
NN_cmova, 229,
NN_cmovb, 230,
NN_cmovbe, 231,
NN_cmovg, 232,
NN_cmovge, 233,
NN_cmovl, 234,
NN_cmovle, 235,
NN_cmovnb, 236,
NN_cmovno, 237,
NN_cmovnp, 238,
NN_cmovns, 239,
NN_cmovnz, 240,
NN_cmovo, 241,
NN_cmovp, 242,
NN_cmovs, 243,
NN_cmovz, 244,
NN_fcmovb, 245,
NN_fcmove, 246,
NN_fcmovbe, 247,
NN_fcmovu, 248,
NN_fcmovnb, 249,
NN_fcmovne, 250,
NN_fcmovnbe, 251,
NN_fcmovnu, 252,
NN_fcomi, 253,
NN_fucomi, 254,
NN_fcomip, 255,
NN_fucomip, 256,
NN_rdpmc, 257,
NN_fld, 258,
NN_fst, 259,
NN_fstp, 260,
NN_fxch, 261,
NN_fild, 262,
NN_fist, 263,
NN_fistp, 264,
NN_fbld, 265,
NN_fbstp, 266,
NN_fadd, 267,
NN_faddp, 268,
NN_fiadd, 269,
NN_fsub, 270,
NN_fsubp, 271,
NN_fisub, 272,
NN_fsubr, 273,
NN_fsubrp, 274,
NN_fisubr, 275,
NN_fmul, 276,
NN_fmulp, 277,
NN_fimul, 278,
NN_fdiv, 279,
NN_fdivp, 280,
NN_fidiv, 281,
NN_fdivr, 282,
NN_fdivrp, 283,
NN_fidivr, 284,
NN_fsqrt, 285,
NN_fscale, 286,
NN_fprem, 287,
NN_frndint, 288,
NN_fxtract, 289,
NN_fabs, 290,
NN_fchs, 291,
NN_fcom, 292,
NN_fcomp, 293,
NN_fcompp, 294,
NN_ficom, 295,
NN_ficomp, 296,
NN_ftst, 297,
NN_fxam, 298,
NN_fptan, 299,
NN_fpatan, 300,
NN_f2xm1, 301,
NN_fyl2x, 302,
NN_fyl2xp1, 303,
NN_fldz, 304,
NN_fld1, 305,
NN_fldpi, 306,
NN_fldl2t, 307,
NN_fldl2e, 308,
NN_fldlg2, 309,
NN_fldln2, 310,
NN_finit, 311,
NN_fninit, 312,
NN_fsetpm, 313,
NN_fldcw, 314,
NN_fstcw, 315,
NN_fnstcw, 316,
NN_fstsw, 317,
NN_fnstsw, 318,
NN_fclex, 319,
NN_fnclex, 320,
NN_fstenv, 321,
NN_fnstenv, 322,
NN_fldenv, 323,
NN_fsave, 324,
NN_fnsave, 325,
NN_frstor, 326,
NN_fincstp, 327,
NN_fdecstp, 328,
NN_ffree, 329,
NN_fnop, 330,
NN_feni, 331,
NN_fneni, 332,
NN_fdisi, 333,
NN_fndisi, 334,
NN_fprem1, 335,
NN_fsincos, 336,
NN_fsin, 337,
NN_fcos, 338,
NN_fucom, 339,
NN_fucomp, 340,
NN_fucompp, 341,
NN_setalc, 342,
NN_svdc, 343,
NN_rsdc, 344,
NN_svldt, 345,
NN_rsldt, 346,
NN_svts, 347, 
NN_rsts, 348,
NN_icebp, 349,
NN_loadall, 350,
NN_emms, 351,
NN_movd, 352,
NN_movq, 353,
NN_packsswb, 354,
NN_packssdw, 355,
NN_packuswb, 356,
NN_paddb, 357,
NN_paddw, 358,
NN_paddd, 359,
NN_paddsb, 360,
NN_paddsw, 361,
NN_paddusb, 362,
NN_paddusw, 363,
NN_pand, 364,
NN_pandn, 365,
NN_pcmpeqb, 366,
NN_pcmpeqw, 367,
NN_pcmpeqd, 368,
NN_pcmpgtb, 369,
NN_pcmpgtw, 370,
NN_pcmpgtd, 371,
NN_pmaddwd, 372,
NN_pmulhw, 373,
NN_pmullw, 374,
NN_por, 375,
NN_psllw, 376,
NN_pslld, 377,
NN_psllq, 378,
NN_psraw, 379,
NN_psrad, 380,
NN_psrlw, 381,
NN_psrld, 382,
NN_psrlq, 383,
NN_psubb, 384,
NN_psubw, 385,
NN_psubd, 386,
NN_psubsb, 387,
NN_psubsw, 388,
NN_psubusb, 389,
NN_psubusw, 390,
NN_punpckhbw, 391,
NN_punpckhwd, 392,
NN_punpckhdq, 393,
NN_punpcklbw, 394,
NN_punpcklwd, 395,
NN_punpckldq, 396,
NN_pxor, 397,
NN_fxsave, 398,
NN_fxrstor, 399,
NN_sysenter, 400,
NN_sysexit, 401,
NN_pavgusb, 402,
NN_pfadd, 403,
NN_pfsub, 404,
NN_pfsubr, 405,
NN_pfacc, 406,
NN_pfcmpge, 407,
NN_pfcmpgt, 408,
NN_pfcmpeq, 409,
NN_pfmin, 410,
NN_pfmax, 411,
NN_pi2fd, 412,
NN_pf2id, 413,
NN_pfrcp, 414,
NN_pfrsqrt, 415,
NN_pfmul, 416,
NN_pfrcpit1, 417,
NN_pfrsqit1, 418,
NN_pfrcpit2, 419,
NN_pmulhrw, 420,
NN_femms, 421,
NN_prefetch, 422,
NN_prefetchw, 423,
NN_addps, 424,
NN_addss, 425,
NN_andnps, 426,
NN_andps, 427,
NN_cmpps, 428,
NN_cmpss, 429,
NN_comiss, 430,
NN_cvtpi2ps, 431,
NN_cvtps2pi, 432,
NN_cvtsi2ss, 433,
NN_cvtss2si, 434,
NN_cvttps2pi, 435,
NN_cvttss2si, 436,
NN_divps, 437,
NN_divss, 438,
NN_ldmxcsr, 439,
NN_maxps, 440,
NN_maxss, 441,
NN_minps, 442,
NN_minss, 443,
NN_movaps, 444,
NN_movhlps, 445,
NN_movhps, 446,
NN_movlhps, 447,
NN_movlps, 448,
NN_movmskps, 449,
NN_movss, 450,
NN_movups, 451,
NN_mulps, 452,
NN_mulss, 453,
NN_orps, 454,
NN_rcpps, 455,
NN_rcpss, 456,
NN_rsqrtps, 457,
NN_rsqrtss, 458,
NN_shufps, 459,
NN_sqrtps, 460,
NN_sqrtss, 461,
NN_stmxcsr, 462,
NN_subps, 463,
NN_subss, 464,
NN_ucomiss, 465,
NN_unpckhps, 466,
NN_unpcklps, 467,
NN_xorps, 468,
NN_pavgb, 469,
NN_pavgw, 470,
NN_pextrw, 471,
NN_pinsrw, 472,
NN_pmaxsw, 473,
NN_pmaxub, 474,
NN_pminsw, 475,
NN_pminub, 476,
NN_pmovmskb, 477,
NN_pmulhuw, 478,
NN_psadbw, 479,
NN_pshufw, 480,
NN_maskmovq, 481,
NN_movntps, 482,
NN_movntq, 483,
NN_prefetcht0, 484,
NN_prefetcht1, 485,
NN_prefetcht2, 486,
NN_prefetchnta, 487,
NN_sfence, 488,
NN_cmpeqps, 489,
NN_cmpltps, 490,
NN_cmpleps, 491,
NN_cmpunordps, 492,
NN_cmpneqps, 493,
NN_cmpnltps, 494,
NN_cmpnleps, 495,
NN_cmpordps, 496,
NN_cmpeqss, 497,
NN_cmpltss, 498,
NN_cmpless, 499,
NN_cmpunordss, 500,
NN_cmpneqss, 501,
NN_cmpnltss, 502,
NN_cmpnless, 503,
NN_cmpordss, 504,
NN_pf2iw, 505,
NN_pfnacc, 506,
NN_pfpnacc, 507,
NN_pi2fw, 508,
NN_pswapd, 509,
NN_fstp1, 510,
NN_fcom2, 511,
NN_fcomp3, 512,
NN_fxch4, 513,
NN_fcomp5, 514,
NN_ffreep, 515,
NN_fxch7, 516,
NN_fstp8, 517,
NN_fstp9, 518,
NN_addpd, 519,
NN_addsd, 520,
NN_andnpd, 521,
NN_andpd, 522,
NN_clflush, 523,
NN_cmppd, 524,
NN_cmpsd, 525,
NN_comisd, 526,
NN_cvtdq2pd, 527,
NN_cvtdq2ps, 528,
NN_cvtpd2dq, 529,
NN_cvtpd2pi, 530,
NN_cvtpd2ps, 531,
NN_cvtpi2pd, 532,
NN_cvtps2dq, 533,
NN_cvtps2pd, 534,
NN_cvtsd2si, 535,
NN_cvtsd2ss, 536,
NN_cvtsi2sd, 537,
NN_cvtss2sd, 538,
NN_cvttpd2dq, 539,
NN_cvttpd2pi, 540,
NN_cvttps2dq, 541,
NN_cvttsd2si, 542,
NN_divpd, 543,
NN_divsd, 544,
NN_lfence, 545,
NN_maskmovdqu, 546,
NN_maxpd, 547,
NN_maxsd, 548,
NN_mfence, 549,
NN_minpd, 550,
NN_minsd, 551,
NN_movapd, 552,
NN_movdq2q, 553,
NN_movdqa, 554,
NN_movdqu, 555,
NN_movhpd, 556,
NN_movlpd, 557,
NN_movmskpd, 558,
NN_movntdq, 559,
NN_movnti, 560,
NN_movntpd, 561,
NN_movq2dq, 562,
NN_movsd, 563,
NN_movupd, 564,
NN_mulpd, 565,
NN_mulsd, 566,
NN_orpd, 567,
NN_paddq, 568,
NN_pause, 569,
NN_pmuludq, 570,
NN_pshufd, 571,
NN_pshufhw, 572,
NN_pshuflw, 573,
NN_pslldq, 574,
NN_psrldq, 575,
NN_psubq, 576,
NN_punpckhqdq, 577, 
NN_punpcklqdq, 578,
NN_shufpd, 579,
NN_sqrtpd, 580,
NN_sqrtsd, 581,
NN_subpd, 582,
NN_subsd, 583,
NN_ucomisd, 584,
NN_unpckhpd, 585,
NN_unpcklpd, 586,
NN_xorpd, 587,
NN_syscall, 588,
NN_sysret, 589};


#endif




